clear all
close all
%% This script only tests and plots the results of the signal processing and choosing of values
%some start values
t_num = 24;                      % Number of time blocks
t_len = 5;                       % Time block spacing 
t = 1;                           % Length of time blocks                
welchlap = [1, 3, 50];           % 1 is welch on and 0 is welch of, how many segments which is going to be used on the time length t_len and amount which is going to overlap
welchtype = 'm';                 % Type of welch method used, home made or pwelch

freq = [100 200 400 600 800 1000];  %frequency values

% The signal processing
[indb, Fs, N, fsamp, mfsamp, octmfsamp, rmfsamp, romfsamp, smfsamp, mid] = SigProc(1,t,t_num,t_len, welchlap, welchtype, freq);

bl = Fs*t;                      % Length of timeblock in samples
K = welchlap(2);                % Number of segments the welch is dividing the time block in
M = round(2*bl/(K+1));          % Length of each welch segment

df = Fs/N;                      % Frequency resolution
f = 0:df:Fs/2-df;               % The frequency values
L = length(smfsamp);            % Length of the signal
% Create time vector for the signal around the mid
tmax = L - mid;                 
tmin = -mid;
time = (tmin/(60*t) + 1/(60*t)):1/(60*t):tmax/(60*t);

% Create time vector for the chosen values
tmint = -t*t_len*t_num/2;
tmaxt = t*t_len*t_num/2;
timet = tmint/(60*t):t_len/(60*t):tmaxt/(60*t);

    %The octavbands and center frequencies
    fomax = max(f);
    order = floor(10*log10(fomax));
    n = 1:order;
    octfreq = zeros(3,length(n));
    for i = 1:length(n)
        octfreq(2,i) = 10^(n(i)/10);
        octfreq(1,i) = octfreq(2,i)*2^(1/6);
        octfreq(3,i) = octfreq(2,i)*2^(-1/6);
    end

%the amplitude in dB with ref of 1 uPa
ref = (1*10^-6);
mfsamp = 20*log10((mfsamp)/(ref));
%octmfsamp = 20*log10((octmfsamp)/(ref));
rmfsamp = 20*log10((rmfsamp)/(ref));
romfsamp = 20*log10((romfsamp)/(ref));
% smfsamp = 20*log10((smfsamp)/(ref));

%all levels bellow minlim is set to this level
minlim = 60;
mfsize = size(mfsamp);
%octmfsize = size(octmfsamp);
% rmfsize = size(rmfsamp);
% romfsize = size(romfsamp);
smfsize = size(smfsamp);
for i = 1:mfsize(2)
    for j = 1:mfsize(1)
       if mfsamp(j,i) < minlim
           mfsamp(j,i) = minlim;
       end
    end
%     for j = 1:octmfsize(1)
%        if octmfsamp(j,i) < minlim
%            octmfsamp(j,i) = minlim;
%        end
%     end
%     for j = 1:smfsize(1)
%        if smfsamp(j,i) < minlim
%            smfsamp(j,i) = minlim;
%        end
%     end
end

% figure 
% plot(time,smfsamp,'DisplayName','Sum of frequency amplitude at each time block')
% xlabel('Time (min)')
% ylabel('Amplitude in Pressure  (Pa)')
% xlim([time(1) time(length(time))])

%% Plot spectrum
%plot magnitude spekter max 3000
% figure
% pcolor(time,f,mfsamp),shading('interp');
% caxis([min(min(mfsamp)), max(max(mfsamp))])
% h = colorbar('location','EastOutside');
% ylabel(h, 'Power in dB re 1 \mu Pa ^2/Hz')
% xlabel('Time (min)')
% ylabel('Frequency (Hz)')
% xlim([time(1) time(length(time))])
% 
% % plot spektrum at mid of octavband, 1 Hz band
% figure
% semilogx(f,mfsamp(:,mid));
% % ylim([0 200])
% xlabel('Frequency (Hz)')
% ylabel('Power in dB re 1 \mu Pa ^2/Hz')


%% Welch spectrum estimation
if (welchtype == 'h')
    f = 0:df:Fs/2-df;
elseif (welchtype == 'm')
                lest = 0;
            Mn = 1;
            teller = 1;
            while (lest == 0)
                if ((2^teller <= M) && (M < 2^(teller+1)))
                    Mn = 2^teller;
                    lest = 1;
                end
                teller = teller + 1;
            end
    f = 0:1:Mn;
end
% plot magnitude spekter
figure
pcolor(time,f,mfsamp),shading('interp');
caxis([min(min(mfsamp)), max(max(mfsamp))])
h = colorbar('location','EastOutside');
ylabel(h, 'Power in dB re 1 \mu Pa ^2/Hz')
xlabel('Time (min)')
ylabel('Frequency (Hz)')
xlim([time(1) time(length(time))])

f = 0:1:3000;
mfsamp3 = mfsamp(1:1:3001,:);
% plot magnitude spekter max 3000
figure
pcolor((1:(size(mfsamp3,2))),f,mfsamp3),shading('interp');
caxis([min(min(mfsamp3)), max(max(mfsamp3))])
h = colorbar('location','EastOutside');
ylabel(h, 'Power in dB re 1 \mu Pa ^2/Hz')
xlabel('Time (min)')
ylabel('Frequency (Hz)')
%xlim([time(1) time(length(time))])

if (welchtype == 'h')
    f = 0:df:Fs/2-df;
elseif (welchtype == 'm')
            lest = 0;
            Mn = 1;
            teller = 1;
            while (lest == 0)
                if ((2^teller <= M) && (M < 2^(teller+1)))
                    Mn = 2^teller;
                    lest = 1;
                end
                teller = teller + 1;
            end
    f = 0:1:Mn;
end
% plot spektrum at mid
figure
semilogx(f,mfsamp(:,mid));
xlabel('Frequency (Hz)')
ylabel('Power in dB re 1 \mu Pa ^2/Hz')
xlim([min(f) max(f)]);
ylim([0 max(mfsamp(:,mid))]);

%% Octave averaging at 1/3
% f = 0:df:Fs/2-df;
% %turn octav averiging from 1/3 octav band to 1 Hz band, using the averaged
% %as the start point and the next averaged as the end point in each averaged
% %band
% octfreq = round(octfreq);
% octmffreq = zeros(octfreq(1,size(octfreq,2)-1),1);
% octmfsig = zeros(octfreq(1,size(octfreq,2)-1),1);
% for i = 1:(size(octfreq,2)-1)
%     xmin = octfreq(3,i);
%     xmax = octfreq(1,i);
%     ymin = octmfsamp(i,mid);
%     ymax = octmfsamp(i+1,mid);
%     
%     octmffreq(xmin:xmax) = xmin:xmax;
%     octmfsig(xmin:xmax) = ymin + ((ymax-ymin)/(xmax-xmin))*((xmin:xmax)-xmin);
% end
%return octav band in 1 Hz
%         %The octavbands and center frequencies
%         fomax = max(freq);
%         order = floor(10*log10(fomax))+1;
%         n = 1:order;
%         octfreq = zeros(3,length(n));
%         for i = 1:length(n)
%             octfreq(2,i) = 10^(n(i)/10);
%             octfreq(1,i) = octfreq(2,i)*2^(1/6);
%             octfreq(3,i) = octfreq(2,i)*2^(-1/6);
%         end
%         
%         f = 1:max(max(octfreq)); 
%         
%         %find the index of the octavfreq
%         %find the index of the octavfreq
%         indof = zeros(1,length(freq));
%         for i = 1:length(freq)
%             fsize = size(find(f == freq(i)));
%             if 0 == fsize(2)
%                 indof(i) = find(f == freq(i)-1);
%             else
%                 indof(i) = find(f == freq(i));
%             end
%         end
% 
%         %octavband
%         octmfsampt = zeros(order,length(indb));
%         octfreq = round(octfreq);
%         octmffreq = zeros(octfreq(1,size(octfreq,2)-1),1);
%         octmfsig = zeros(octfreq(1,size(octfreq,2)-1),length(indb));
%         for i = 1:length(indb)
%             %averaging octav averiging
%             octmfsampt(:,i)= octavg(mfsamp(:,indb(i)), f);
%             
%             %turn octav averiging from 1/3 octav band to 1 Hz band, using the averaged
%             %as the start point and the next averaged as the end point in each averaged
%             %band
%             for j = 1:(size(octfreq,2)-1)
%                 xmin = octfreq(3,j);
%                 xmax = octfreq(1,j);
%                 ymin = octmfsampt(j,i);
%                 ymax = octmfsampt(j+1,i);
% 
%                 octmffreq(xmin:xmax) = xmin:xmax;
%                 octmfsig(xmin:xmax,i) = ymin + ((ymax-ymin)/(xmax-xmin))*((xmin:xmax)-xmin);
%             end
%         end
%         %finds the amplitude values of octavband 
%         vmfsamp = octmfsig(indof,:);
%         vmfsamp = 20*log10((vmfsamp.^2)/(ref^2));

%% Spectrum octaveband
% % plot spektrum at mid of octavband, 1 Hz band
% figure
% semilogx(indof,vmfsamp(:,11));
% % ylim([0 200])
% xlabel('Frequency (Hz)')
% ylabel('Power in dB re 1 \mu Pa ^2/Hz')

% plot spektrum at mid of octavband 1 Hz band
% figure
% semilogx(octfreq(3,:),octmfsamp(:,mid));
% ylim([0 200])
% xlabel('Frequency (Hz)')
% ylabel('Power in dB re 1 \mu Pa ^2/Hz')

% % plot spektrum at mid of octavband bar plot
% octfreq = round(octfreq);
% f = octfreq(3,1):octfreq(1,size(octmfsamp,1));
% octmfsampob = zeros(length(f),1);
% for i = 1:size(octmfsamp,1)
%     for j = octfreq(3,i):octfreq(1,i)
%         octmfsampob(j) = octmfsamp(i,mid);
%     end
% end
% figure
% semilogx(f,octmfsampob);
% ylim([0 200])
% xlabel('Frequency (Hz)')
% ylabel('Power in dB re 1 \mu Pa ^2/Hz')


% plot magnitude spekter with octavband
% figure
% contourf(time,octfreq(2,:),octmfsamp)
% caxis([min(min(octmfsamp)), max(max(octmfsamp))])
% h = colorbar('location','EastOutside');
% ylabel(h, 'Amplitude in dB re 1 \mu Pa ^2/Hz')
% xlabel('Time (min)')
% ylabel('Frequency (Hz)')
% xlim([time(1) time(length(time))])

% plot the values which is taken out of the magnitude spekter
% figure
% contourf(timet,freq,rmfsamp)
% caxis([min(min(rmfsamp)), max(max(rmfsamp))])
% h = colorbar('location','EastOutside');
% ylabel(h, 'Amplitude in dB re 1 \mu Pa/Hz')
% xlabel('Time (min)')
% ylabel('Frequency (Hz)')
% xlim([timet(1) timet(length(timet))])

% plot the values which is taken out of the magnitude spekter with oct
% figure
% contourf(timet,freq,romfsamp)
% caxis([min(min(romfsamp)), max(max(romfsamp))])
% h = colorbar('location','EastOutside');
% ylabel(h, 'Amplitude in dB re 1 \mu Pa/Hz')
% xlabel('Time (min)')
% ylabel('Frequency (Hz)')
% xlim([timet(1) timet(length(timet))])
