clear all

%% Script to plot the recorded AIS distance and the tracking

nsample = 1;
%Load distance and time for the sample given as dist and time_int, the time around CPA for the
%recorded sample is found by manually
switch nsample
        case 1
        %sample 1
        load('sample1 ship path')
        minsamptime = -6.8;
        maxsamptime = 7.87;
 
        case 2
        %sample 2
       
        case 3
        %sample 3
        load('sample3 ship path')
        minsamptime = -4.867;
        maxsamptime = 7.05;
           
end
        

%sets the lowest time value to se the time of start of the recording of
%this ship
mintime = min(time_int);
timepas = time_int - mintime;
timepas = timepas*24*60;
dt = timepas(2) - timepas(1);

%finds CPA and make the time go around this point 
[mindist, ind] = min(dist);

mintimepas = round(minsamptime/dt);
maxtimepas = round(maxsamptime/dt);

time = timepas((ind+mintimepas):(ind+maxtimepas)) - timepas(ind);
distance = dist((ind+mintimepas):(ind+maxtimepas));

%The ship path with the estimated paramters
vs = 8.04;          % Ship velocity
dcpa = 3.75;        % Distance at CPA

rb = time.*vs*60;
rt = sqrt((rb).^2 + dcpa^2);

%plot distance over time
figure
hold
plot(time,distance,'DisplayName','AIS data')
plot(time,rt,'r','DisplayName','Estimated data')
legend('show');
xlabel('Time (min)')
ylabel('Range (m)')
xlim([min(time) max(time)])
ylim([0 max(distance)])
hold off




