clear all
close all
%% A script to test and plot the noise created 
% A simple algorithm creating a matrix of the cost function based on the two parameters
func=@objectivefunction;          % Cost function
%cp=[1300,1700, 1500,1900];
vs=[2*0.5144, 40*0.5144];
dcpa=[100,2000];
t_len = 1;                        % Length of time block in seconds
t_bet = 5;                        % Number of timeblocks between each chosen timebloc
t_num = 20;
freq = [100 200 400 700 1000];    % Frequencies (Hz)
v_s=[10*0.5144];                  % Ship speed (m/s)
d_cpa=[250];                      % Closest point of approach (m)

%Set problem upper and lower bounds.
Pparams.ub=[vs(2) dcpa(2)];
Pparams.lb=[vs(1) dcpa(1)];
ub=Pparams.ub;
lb=Pparams.lb;
par1 = lb(1):0.1:ub(1);
par2 = lb(2):1:ub(2);

%% Produce Synthetic Data
ds = 50;
%Shared
Sparam.t_len = 1;               % Length of time block in seconds
Sparam.t_bet = 3;               % Number of timeblocks between each chosen timeblock
Sparam.t_num = t_num;           % Number of time blocks needed for the comparison
Sparam.freq = [103 308 476 550 720 890];   %Frequencies (Hz), sample 3 [103 308 476 550 720 890], sample 1 [138 235 343 479 680 878], [138 232 352 495 680 810]
Sparam.d=[200, 3.325, 200];     % Reciver, source and seafloor depth (m), sample 3 [3.325], sample 1 [1.4]
Sparam.dr=1;                    % Range resolution
Sparam.df = 1;                  % Frequency resolution
%LloydMirr
nLloyd = 5;                     % Order of syntetic Lloyd mirror
Sparam.mLloyd = 3;              % Order of modeled Lloyd mirror
Sparam.cp=[1482, 1502];         % P wave speed (m/s)
Sparam.rho=[1.0, 1.500]*1000;     % Density (kg/m^3)
Sparam.vs=[10*0.5144];          % Ship speed, syntetic data (m/s)
Sparam.dcpa=[250];              % Closest point of approach, syntetic data (m)
%RAM
Rparam.SP=...                   % Sound speed profiel speed (m/s) and depth (m)
[1483, 1492, 1486, 1482, 1478, 1471, 1471, 1475, 1480, 1482, 1482.5, 1483, 1483;...
0 5 10 15 20 30 40 50 60 70 80 90 200];
Rparam.depR = [0 100];          % Start of sea bottom (m), clay and mud (calculated from the bottom)
Rparam.cpR=[1500, 1615];        % P wave speed (m/s), clay and mud
Rparam.rhoR=[1.5, 1.8];         % Density (g/m^3), clay and mud
Rparam.atnR=[0.2, 0.9];         % Attenuation (dB/alfa), clay and mud
%Different processes
Sparam.shippath = 'l';          % Simulating of the ship path, 's' symetrical around cpa, 'b' before cpa and 'a' after cpa, 'l' before and abit after and 'k' which is ater and abit before
Sparam.sbal = 2;                % How many of the t_num time blocks is before or after the cpa when using shippath 'l' or 'k'
Sparam.tstart = 0;              % Decides if the ship path is created from CPA, value 0, or from a point 'x' timeblocks away, where positive values are in after CPA direction
Sparam.noi = 'u';               % 'u' no noise added, 'n' noise added
Sparam.dmodel = 'r';            % Chose type of data model uses, 's' syntetic or 'r' real
Sparam.model = 'L';             % Which model used, 'L' Lloyd 'R' RAM
Sparam.nsample = 3;             % Which time sample is uesed 1, 2 or 3
Sparam.ftype = 'w';             % Return the 'n' 1 Hz band values, 'w' welch spektral estimation and 'o' octavband of the real og syntetic data
Sparam.welchlap = [3 50];       % Number of overlapping segements and overlap in percent when using welch
Sparam.welchtype = 'm';         % 'h' for home made welch estimation, 'm' for matlab pwelch
Sparam.Ltype = 'n';             % Return the 'n' 1 Hz band values and 'o' octavband of the Lloyd mirror
Sparam.octavband = 'l';         % 'n' constant value of the octavband averaging or 'l' 1 Hz band linearisation of the octavband averaging

% RAM has to be stored in a matrix and values taken from this matrix or
% else the code will stop working
if (Sparam.model == 'R')
    Sparam.RV = RAMV(Rparam, Sparam, Pparams);
end

%Syntetic data
Sparam.df = 1;                  % The frequency resolution is wanted to be 1 Hz
shippath = Sparam.shippath;     % Type of ship path
sbal = Sparam.sbal;             % How many of the t_num time blocks is before or after the cpa when using shippath
    %time between each timeblock measured and with v_s can find distence
    %between each timeblock and can creating the time series of the signal in range 
   if (v_s == 0)                        % Standing still
        rb = zeros(t_num+1,1);
   else
        if (shippath == 's')            % Ship path symetric around CPA
            rb_min = -t_len*t_bet*round(t_num/2)*v_s + tstart*v_s;
            rb_max = t_len*t_bet*round(t_num/2)*v_s + tstart*v_s;
            steps = (rb_max-rb_min)/t_num;
            rb = rb_min:steps:rb_max;
        elseif (shippath == 'b')        % Ship path before CPA
            rb_min = -t_len*t_bet*round(t_num)*v_s + tstart*v_s;
            rb_max = tstart*v_s;
            steps = (rb_max-rb_min)/t_num;
            rb = rb_min:steps:rb_max;
        elseif (shippath == 'a')        % Ship path after CPA
            rb_min = tstart*v_s;
            rb_max = t_len*t_bet*round(t_num)*v_s + tstart*v_s;
            steps = (rb_max-rb_min)/t_num;
            rb = rb_min:steps:rb_max;
        elseif (shippath == 'l')        % Ship path abit before CPA and a little after
            rb_min = -t_len*t_bet*round(t_num-sbal)*v_s + tstart*v_s;
            rb_max = t_len*t_bet*round(sbal)*v_s + tstart*v_s;
            steps = (rb_max-rb_min)/t_num;
            rb = rb_min:steps:rb_max;
        elseif (shippath == 'k')        % Ship path abit after CPA and a little before
            rb_min = -t_len*t_bet*round(sbal)*v_s + tstart*v_s;
            rb_max = t_len*t_bet*round(t_num - sbal)*v_s + tstart*v_s;
            steps = (rb_max-rb_min)/t_num;
            rb = rb_min:steps:rb_max;
        end
   end

% Create synthetic data or use measured recordings
dmodel = Sparam.dmodel;
if (dmodel == 's')
    %Syntetic data
    [RL] = LMmodel(Sparam,nLloyd);
elseif (dmodel == 'r')
    %Real data
    [RL, Sparam.df] = SigProc(Sparam);
end

% Noise created and 
f = Sparam.freq;
SNRN = 15;
Nadj = ((mean(abs(RL(:,t_num/2+1)))/(10^(SNRN/20)))/mean(AmbNoise(f)));
Noise = AmbNoise(f)*Nadj;
NoiseA = ones(length(f),size(RL,2));
for i = 1:size(RL,2)
    NoiseA(:,i) = Noise'.*NoiseA(:,i);
end
SNRA = 20*log10(abs(RL)./NoiseA);

%% Plot
figure
pcolor(rb,f,SNRA),shading('interp');
title('SNR')
h = colorbar('location','EastOutside');
ylabel(h, 'SNR (dB)')
xlabel('Timeblock ')
ylabel('Frequency (Hz)')

figure
plot(f,SNRA(:,t_num/2 +1))
title('SNR at closest point of approach (dB)')
xlabel('Frequency (Hz)')
ylabel('SNR (dB)')

figure
plot(f,SNRA(:,t_num +1))
title('SNR at the farest away timeblock (dB)')
xlabel('Frequency (Hz)')
ylabel('SNR (dB)')

figure
plot(rb,SNRA(1,:))
title('SNR at 100 Hz (dB)')
xlabel('Timeblock')
ylabel('SNR (dB)')

figure
plot(rb,SNRA(3,:))
title('SNR at 400 Hz (dB)')
xlabel('Timeblock')
ylabel('SNR (dB)')

figure
plot(rb,SNRA(length(f),:))
title('SNR at 1000 Hz (dB)')
xlabel('Timeblock')
ylabel('SNR (dB)')

plot(f,Noise)
title('Pressure for noise (dB)')
xlabel('Frequency (Hz)')
ylabel('Pressure (Pa)')

plot(f,abs(RL(:,t_num/2+1)))
title('Pressure at closest point of approach (dB)')
xlabel('Frequency (Hz)')
ylabel('Pressure (Pa)')