%% Slant range
function [R_n1,R_n2, R_p1 ,R_p2  ] = Range(n,d_w, d_s,d_b,r)
%n is number of bottom reflections, d_w is reciver depth, d_s is source depth, r is horizontal range
%This function assume constant sound speed, homogeneus media and finds the
%slant range to the boat
    if (d_w == d_b)
        R_n1 = sqrt(((2*n)*d_b +d_w -d_s)^2 + r^2);
        R_n2 = sqrt(((2*n)*d_b +d_w -d_s)^2 + r^2);
        R_p1 = sqrt(((2*n)*d_b +d_w +d_s)^2 + r^2);
        R_p2 = sqrt(((2*n)*d_b +d_w +d_s)^2 + r^2);
    else %for cases where the receiver isn't at the sea floor
        R_n1 = sqrt(((2*n)*d_b +d_w -d_s)^2 + r^2);
        R_n2 = sqrt(((2*n +1)*d_b +d_w -d_s)^2 + r^2);
        R_p1 = sqrt(((2*n)*d_b +d_w +d_s)^2 + r^2);
        R_p2 = sqrt(((2*n +1)*d_b +d_w +d_s)^2 + r^2);
    end

end

