clear all
close all
%% A script to see if the right values are chosen from the signal

%some start values
t_num = 24;                             % Number of time blocks
t_bet = 5;                              % Time block spacing 
t_len = 1;                              % Length of time blocks
freq = [100 200 300 500 600 800 900];   %Frequency values

Sparam.shippath = 'l';          % Simulating of the ship path, 's' symetrical around cpa, 'b' before cpa and 'a' after cpa, 'l' before and abit after and 'k' which is ater and abit before
Sparam.sbal = 2;                % How many of the t_num time blocks is before or after the cpa when using shippath 'l' or 'k'
Sparam.tstart = 0;              % How many of the t_num time blocks is before or after the cpa when using shippath
Sparam.nsample = 2;             % Which time sample are used
Sparam.ftype = 'w';             % Return the 'n' 1 Hz band values, 'w' welch spektral estimation and 'o' octavband of the real og syntetic data
Sparam.welchlap = [3 50];       % Number of overlapping segements and overlap in percent when using welch
Sparam.welchtype = 'm';         % 'h' for home made welch estimation, 'm' for matlab pwelch
Sparam.octavband = 'l';         % 'n' constant value of the octavband averaging or 'l' 1 Hz band linearisation of the octavband averaging
Sparam.t_num = t_num;
Sparam.t_bet = t_bet;
Sparam.t_len = t_len;
Sparam.freq = freq;

% Use SigProc to process real data
[vmfsamp, df] = SigProc(Sparam);
Fs = 9000;                      % Sampling of recorded data
f = 0:df:Fs/2-df;               % Frequency values of processed data

% Make timeline 
tmint = -t_len*t_bet*t_num/2;   
tmaxt = t_len*t_bet*t_num/2;
timet = tmint/(60*t_len):t_bet/(60*t_len):tmaxt/(60*t_len);

%The amplitude in dB with ref of 1 uPa
ref = (1*10^-6);
vmfsamp = 20*log10((vmfsamp.^2)/(ref^2));

%all levels bellow 60 dB is set to 60 dB
minlim = 50;
vmfsize = size(vmfsamp);
for i = 1:vmfsize(2)
    for j = 1:vmfsize(1)
       if vmfsamp(j,i) < minlim
           vmfsamp(j,i) = minlim;
       end
    end
end

% Plot the chosen data 
figure
pcolor(timet,freq,vmfsamp);shading('interp');
caxis([min(min(vmfsamp)), max(max(vmfsamp))])
h = colorbar('location','EastOutside');
ylabel(h, 'Amplitude in dB re 1 \mu Pa/Hz')
xlabel('Time (min)')
ylabel('Frequency (Hz)')
xlim([timet(1) timet(length(timet))])


