%% The upgoing and down going ray paths
function [pp, pn] = UpDown(n,k,Rp,Rn,Vp,Vn)
%Up and Downgoing Field, where n is number of reflections from the bottom,
%k is wave number, Ru is range of upgoing field and Rd is range of
%downgoing field, Vu and Vd is the reflection coefficient of up and down
%going field. The down going field is the contribution from the source,
%and the up going field is the contribution from the mirror source. The
%(-1) is for each time it's reflected from the sea surface which is
%assumed to give total reflection.

    pp1 = ((-1)^(n+1))*(Vp(1)^(n))*(exp(1i*k*Rp(1))*(1)/Rp(1));
    pp2 = ((-1)^(n+1))*(Vp(2)^(n))*(exp(1i*k*Rp(2))*(Vp(2))/Rp(2));
    pp = pp1 + pp2;
    
    pn1 = ((-1)^n)*(Vn(1)^(n))*(exp(1i*k*Rn(1))*(1)/Rn(1));
    pn2 = ((-1)^(n))*(Vn(2)^(n))*(exp(1i*k*Rn(2))*(Vn(2))/Rn(2));
   pn = pn1 + pn2;

end