%                       COST FUNCTION
%__________________________________________________________________________
%
%Functon first generates modeled data with the given parameters (par), and then
%return error of the cost function when matching this with measured/synthetic signal  
%
%______

function [error, track]=objectivefunction(RLsynth,par,Sparam,track)

popsize=size(par,1);
model = Sparam.model;

RL=zeros(size(RLsynth));
    
    check = 0;
    mLloyd = Sparam.mLloyd;
    %Check if any of the parameters are negative or zero
    for i = length(par)
        if (par(i) <= 0)
           check = 1;
        end
    end
       % The ship can't move backward or be standing stil, because of how the cost
       % function is calculating the error and no of the other parameters
       % can be zero or negative
       if check == 1
           error = 1;
       else
           % Chose between Lloyd mirror or RAM
           if(model == 'L')
                RL=LMmodel2(par,Sparam,mLloyd);
           elseif(model == 'R')
                RL = RAMsearch(par,Sparam);
           end
           % Cost function
           error = misfit(abs(RLsynth),abs(RL));
           
           %-----Tracking the search---------------------------------------
            if (length(par) == 8)
                tracklen = size(track,2)+1;
                track(1,tracklen) = 20*log10(error);        % Saves log of error
                track(2,tracklen) = par(1);                 % Ship velocity
                track(3,tracklen) = par(2);                 % Distance at closest point of approach
                track(4,tracklen) = par(3);                 % Source depth
                track(5,tracklen) = par(4);                 % Seafloor and reciever depth
                track(6,tracklen) = par(5);                 % Sound speed in water
                track(7,tracklen) = par(6);                 % Sound speed in sediment
                track(8,tracklen) = par(7);                 % Density in water
                track(9,tracklen) = par(8);                 % Density in sediment
            end
       end
    

end

