%% Octave avareaging

function [ octresp] = octavg(resp, f)
%1/3 octavband averaging of the amplitude frequency response signal 'resp' and have
%the frequencies f, wher f has  a band of 1 Hz and n orders
    df = f(2)-f(1);
    fomax = max(f);
    order = floor(10*log10(fomax));
    n = 1:order;
    octfreq = zeros(1,length(n));
    octresp = zeros(1,length(n));
    %octaband averaging
    for i = 1:length(n)
        %create the octaveband frequency of order n
        fc = 10^(n(i)/10);
        fmax = fc*2^(1/6);
        fmin = fc*2^(-1/6);
        kmax = round(fmax/df);
        kmin = round(fmin/df);
        octfreq(i) = fc;
        %averaging over the octaveband
        octresp(i) = (1/(kmax-kmin+1))*sum(resp(kmin:kmax));
    end
    
end

