%% Reflection coefficent
function V = refcoff(r,R,c_w,c_s,dens_w,dens_s )
%Reflection coeff, where r is horizontal distance, R is the travel
%distance, c_w and c_s is water and sediment sound speed, dens_w and dens_s
%is water and sediment density
% This function is a simple model and are not considering rough surface or
% shear waves

    %angle
    ang_w = asin(r/R);
    ang_s = asin((c_s/c_w)*(r/R));
    
    %ratio between the two medium
    m = dens_s/dens_w;
    n = c_w/c_s;
    
    %reflection coefficient
    V = ((m*cos(ang_w) - n*cos(ang_s))/(m*cos(ang_w) + n*cos(ang_s)));
   
end

